# Arachni::Reactor

<table>
    <tr>
        <th>Version</th>
        <td>0.1.2</td>
    </tr>
    <tr>
        <th>Github page</th>
        <td><a href="http://github.com/Arachni/arachni-reactor">http://github.com/Arachni/arachni-reactor</a></td>
     <tr/>
    <tr>
        <th>Code Documentation</th>
        <td><a href="http://rubydoc.info/github/Arachni/arachni-reactor/">http://rubydoc.info/github/Arachni/arachni-reactor/</a></td>
    </tr>
    <tr>
       <th>Author</th>
       <td><a href="http://twitter.com/Zap0tek">Tasos Laskos</a></td>
    </tr>
    <tr>
        <th>Twitter</th>
        <td><a href="http://twitter.com/ArachniScanner">@ArachniScanner</a></td>
    </tr>
    <tr>
        <th>Copyright</th>
        <td>2014-2017 <a href="http://www.sarosys.com">Sarosys LLC</a></td>
    </tr>
    <tr>
        <th>License</th>
        <td><a href="file.LICENSE.html">3-clause BSD</a></td>
    </tr>
</table>

## Synopsis

`Arachni::Reactor` is a simple, lightweight, pure-Ruby implementation of the
[Reactor](http://en.wikipedia.org/wiki/Reactor_pattern) pattern, mainly focused
on network connections -- and less so on generic tasks.

## Features

 - Extremely lightweight.
 - Very simple design.
 - Support for TCP/IP and UNIX-domain sockets.
 - TLS encryption.
 - Pure-Ruby.
 - Multi-platform.

## Supported platforms

 - Rubies:
    - MRI >= 1.9
    - Rubinius
    - JRuby
 - Operating Systems:
    - Linux
    - OSX
    - Windows

## Examples

For examples please see the `examples/` directory.

## Installation

    gem install arachni-reactor

## Running the Specs

    rake spec

## Bug reports/Feature requests

Please send your feedback using GitHub's issue system at
[http://github.com/arachni/arachni-reactor/issues](http://github.com/arachni/arachni-reactor/issues).


## License

Arachni::Reactor is provided under the 3-clause BSD license.
See the [LICENSE](https://github.com/Arachni/arachni-reactor/blob/master/LICENSE.md) file for more information.
