watir-webdriver
===============

Watir implementation built on WebDriver's Ruby bindings.
See [introduction mail](https://web.archive.org/web/20140518221755/http://rubyforge.org/pipermail/wtr-development/2009-October/001313.html).

[![Gem Version](https://badge.fury.io/rb/watir-webdriver.svg)](http://badge.fury.io/rb/watir-webdriver)
[![Build Status](https://travis-ci.org/watir/watir-webdriver.svg?branch=master)](https://travis-ci.org/watir/watir-webdriver)
[![Code Climate](https://codeclimate.com/github/watir/watir-webdriver.svg)](https://codeclimate.com/github/watir/watir-webdriver)
[![Dependency Status](https://gemnasium.com/watir/watir-webdriver.svg)](https://gemnasium.com/watir/watir-webdriver)
[![Coverage Status](https://coveralls.io/repos/watir/watir-webdriver/badge.svg?branch=master)](https://coveralls.io/r/watir/watir-webdriver)

Example
-------

```ruby
require 'watir-webdriver'

browser = Watir::Browser.new :firefox
browser.goto "http://google.com"
browser.text_field(name: 'q').set("WebDriver rocks!")
browser.button(name: 'btnG').click
puts browser.url
browser.close
```

Description
-----------

The file in `lib/watir-webdriver/elements/html_generated.rb` is autogenerated from the HTML spec. This is done by extracting the IDL parts from the spec and processing them with the WebIDL gem (link below).

The same is true for `lib/watir-webdriver/elements/svg_elements.rb`.

Specs
-----

watir-webdriver uses [watirspec](http://github.com/watir/watirspec) for testing. After cloning, you should fetch the submodule:

```bash
git submodule init && git submodule update
```

Specs specific to watir-webdriver are found in `spec/*_spec.rb`, with watirspec in `spec/watirspec/`.

Doctests
--------

watir-webdriver uses [yard-doctest](https://github.com/p0deje/yard-doctest) for testing documentation examples.

```bash
rake yard:doctest
```

API docs
--------

* http://rdoc.info/gems/watir-webdriver/ (updated on every release)

See also
--------

* http://watirwebdriver.com
* http://github.com/jarib/webidl
* http://github.com/watir/watirspec
* https://github.com/seleniumhq/selenium

Dependencies
------------

* selenium-webdriver

Note on Patches/Pull Requests
-----------------------------

* Fork the project.
* Make your feature addition or bug fix.
* Add tests for it. This is important so I don't break it in a
  future version unintentionally.
* Commit, do not mess with Rakefile, version, or history.
  (if you want to have your own version, that is fine but bump version in a commit by itself I can ignore when I pull)
* Send me a pull request. Bonus points for topic branches.

Copyright
---------

Copyright (c) 2009-2015 Jari Bakken. See LICENSE for details.
